#include <parallel.h>

void set_distribution(ZIP_MAILER *Mailer,
                      short       Dis_Type,
                      int         rctype,
                      Cdistrib  **Dis,
                      void     ((**Distribution)()),
                      int      ((**Inverse_Distribution)()),
                      int      ((**Distribution_limit)()),
                      int      ((**Distribution_init)()),
                      int         Max_Grid_dim,
                      index       Grid_coor,
                      int         Global_Mat_dim,
                      int        *Local_Mat_dim,
                      int         Extra_param1,
                      int         Extra_param2,
                      void      **Extra)
{
   /* create distribution: */
   *Dis = new_Cdistrib(Mailer, rctype, Dis_Type, NULL);
   *Distribution         = (*Dis) -> mu;
   *Inverse_Distribution = (*Dis) -> mu_i;
   *Distribution_limit   = (*Dis) -> mu_lim;
   *Distribution_init    = (*Dis) -> mu_init;

   /* initialize the distribution accordingly: */
   switch (Dis_Type)
   {
      case CDISTRI_BLINEAR:
      case CDISTRI_BSCATTERED:
      case CDISTRI_GBLINEAR:
      case CDISTRI_GBSCATTERED:
         *Extra = (void *) NEW_CLEAR_ITEM(int ,1);
         *(int *)(*Extra) = Extra_param1;
         break;

      case CDISTRI_G1PARAM:
         *Extra = (void *)NEW_CLEAR_ITEM(CDISTRI_GENL_1PARAM_EXTRA, 1);
         (**Distribution_init)(*Extra, Extra_param2, Max_Grid_dim,
                               Global_Mat_dim);
         break;

      case CDISTRI_G2PARAM:
         *Extra = (void *)NEW_CLEAR_ITEM(CDISTRI_GENL_2PARAM_EXTRA, 1);
         (**Distribution_init)(*Extra, Extra_param1, Extra_param2, Max_Grid_dim,
                               Global_Mat_dim);
                break;

      default:
         break;
    }

    if((*Dis) -> mu_extra != NULL)     /* make distribution use Extra */
    {
        Free((*Dis) -> mu_extra);
        (*Dis) -> mu_extra = *Extra;
    }

    *Local_Mat_dim = (**Distribution_limit)(Grid_coor, Max_Grid_dim,
                                           Global_Mat_dim, *Extra);
}
